<?php
/**
 * The class file for DeleteQuery
 *
 * @author J Jurgens du Toit (JadeIT cc) <jurgens.dutoit@gmail.com> - initial API and implementation
 * @copyright Copyright (c) 2009 JadeIT cc.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available {@link http://www.eclipse.org/legal/epl-v10.html here}
 * @license http://www.eclipse.org/legal/epl-v10.html Eclipse Public License v1.0
 * @package Utilities
 */
/**
 * Base class to handle delete queries
 */
class DeleteQuery extends Query {
	function __construct($table, array $options = array()) {
		parent::__construct('DELETE', $table, $options);
	}

	protected function buildTable() {
		$query = 'DELETE FROM ' . $this->table;
		return $query;
	}

	public function execute(array $parameters = array(), array $options = array()) {
		if ($stmt = parent::execute($parameters, $options)) {
			return $stmt->rowCount();
		}
		return $stmt;
	}
}

